'use strict';

exports.__esModule = true;
exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp, _initialiseProps;

var _react = require('react');

var _Translate = require('translate-maker/lib/Translate');

var _Translate2 = _interopRequireDefault(_Translate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LocaleProvider = (_temp = _class = function (_Component) {
  (0, _inherits3.default)(LocaleProvider, _Component);

  function LocaleProvider(props, context) {
    (0, _classCallCheck3.default)(this, LocaleProvider);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props, context));

    _initialiseProps.call(_this);

    var translate = props.translate,
        locale = props.locale,
        namespace = props.namespace,
        children = props.children,
        controlled = props.controlled,
        rest = (0, _objectWithoutProperties3.default)(props, ['translate', 'locale', 'namespace', 'children', 'controlled']);

    var instance = translate || new _Translate2.default(rest);

    _this.state = {
      translate: instance
    };

    if (locale) {
      instance.setLocale(locale, namespace);
    }
    return _this;
  }

  LocaleProvider.prototype.getChildContext = function getChildContext() {
    return {
      translate: this,
      t: this.t
    };
  };

  LocaleProvider.prototype.componentDidMount = function componentDidMount() {
    var translate = this.state.translate;


    translate.on('locale', this.localeChanged);
    translate.on('changed', this.dataChanged);
  };

  LocaleProvider.prototype.componentWillUnmount = function componentWillUnmount() {
    var translate = this.state.translate;


    translate.removeListener('locale', this.localeChanged);
    translate.removeListener('changed', this.dataChanged);
  };

  LocaleProvider.prototype.componentWillReceiveProps = function componentWillReceiveProps(newProps) {
    var _props = this.props,
        locale = _props.locale,
        namespace = _props.namespace;
    var translate = this.state.translate;


    if (newProps.controlled) {
      if (newProps.locale !== locale) {
        translate.setLocale(newProps.locale, newProps.namespace);
      } else if (newProps.locale && newProps.namespace !== namespace) {
        translate.setLocale(newProps.locale, newProps.namespace);
      }
    }
  };

  LocaleProvider.prototype.get = function get(path, attrs, defaultValue) {
    var translate = this.state.translate;

    return translate.get(path, attrs, defaultValue);
  };

  LocaleProvider.prototype.set = function set(path, value) {
    var translate = this.state.translate;

    return translate.set(path, value);
  };

  LocaleProvider.prototype.setLocale = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(locale) {
      var translate;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!this.props.controlled) {
                _context.next = 2;
                break;
              }

              throw new Error('LocaleProvider is set as controlled component. If you want to use setLocale please set controlled = false');

            case 2:
              translate = this.state.translate;
              _context.next = 5;
              return translate.setLocale(locale);

            case 5:
              return _context.abrupt('return', _context.sent);

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function setLocale(_x) {
      return _ref.apply(this, arguments);
    }

    return setLocale;
  }();

  LocaleProvider.prototype.getLocale = function getLocale() {
    var translate = this.state.translate;

    return translate.getLocale();
  };

  LocaleProvider.prototype.render = function render() {
    return _react.Children.only(this.props.children);
  };

  return LocaleProvider;
}(_react.Component), _class.propTypes = {
  children: _react.PropTypes.node,
  controlled: _react.PropTypes.bool,
  locale: _react.PropTypes.string,
  namespace: _react.PropTypes.string,

  locales: _react.PropTypes.array,
  cache: _react.PropTypes.object,
  data: _react.PropTypes.object,
  adapter: _react.PropTypes.object,
  dotNotation: _react.PropTypes.bool,
  mode: _react.PropTypes.string,
  references: _react.PropTypes.bool,
  variables: _react.PropTypes.bool,
  combinations: _react.PropTypes.bool,
  filters: _react.PropTypes.object,
  translate: _react.PropTypes.object
}, _class.defaultProps = {
  controlled: true
}, _class.childContextTypes = {
  translate: _react.PropTypes.object.isRequired,
  t: _react.PropTypes.func.isRequired
}, _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.t = function (path, attrs, defaultValue) {
    return _this2.get(path, attrs, defaultValue);
  };

  this.dataChanged = function () {
    _this2.forceUpdate();
  };

  this.localeChanged = function (locale) {
    _this2.setState({ locale: locale });
  };
}, _temp);
exports.default = LocaleProvider;