'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _class, _temp;

exports.prepareProps = prepareProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

var _forEach = require('lodash/forEach');

var _forEach2 = _interopRequireDefault(_forEach);

var _LocaleProvider = require('./LocaleProvider');

var _LocaleProvider2 = _interopRequireDefault(_LocaleProvider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function prepareProps(props, localeProvider) {
  var newProps = {};
  var changed = false;

  (0, _forEach2.default)(props, function (value, key) {
    var isReactElement = (0, _react.isValidElement)(value);
    if (!isReactElement) {
      newProps[key] = value;
      return;
    }

    changed = true;
    var _localeProvider$props = localeProvider.props,
        children = _localeProvider$props.children,
        locale = _localeProvider$props.locale,
        rest = (0, _objectWithoutProperties3.default)(_localeProvider$props, ['children', 'locale']);

    newProps[key] = (0, _server.renderToStaticMarkup)(_react2.default.createElement(
      _LocaleProvider2.default,
      rest,
      value
    ));
  });

  return changed ? newProps : props;
}

var Translate = (_temp = _class = function (_Component) {
  (0, _inherits3.default)(Translate, _Component);

  function Translate() {
    (0, _classCallCheck3.default)(this, Translate);
    return (0, _possibleConstructorReturn3.default)(this, _Component.apply(this, arguments));
  }

  Translate.prototype.getPath = function getPath() {
    var path = this.props.path;
    var namespace = this.context.namespace;

    if (!namespace) {
      return path;
    }

    var parentPath = namespace.getPath();
    if (!parentPath) {
      return path;
    }

    return parentPath + '.' + path;
  };

  Translate.prototype.render = function render() {
    var _props = this.props,
        tagName = _props.tagName,
        params = _props.params,
        defaultValue = _props.defaultValue,
        className = _props.className,
        _props$props = _props.props,
        props = _props$props === undefined ? {} : _props$props;


    var path = this.getPath();

    var translate = this.context.translate;


    var currentProps = params || this.props;
    var updatedProps = prepareProps(currentProps, translate);
    var text = translate.get(path, updatedProps, defaultValue);

    if (className && !props.className) {
      props.className = className;
    }

    return _react2.default.createElement(tagName, props, text);
  };

  return Translate;
}(_react.Component), _class.contextTypes = (0, _extends3.default)({}, _LocaleProvider2.default.childContextTypes, {
  namespace: _react.PropTypes.object
}), _class.propTypes = {
  path: _react.PropTypes.string.isRequired,
  tagName: _react.PropTypes.string.isRequired,
  defaultValue: _react.PropTypes.string,
  description: _react.PropTypes.string,
  className: _react.PropTypes.string,
  params: _react.PropTypes.object,
  props: _react.PropTypes.object
}, _class.defaultProps = {
  tagName: 'span'
}, _temp);
exports.default = Translate;